#include <iostream>

using namespace std;
const int N = 500005;
int digits[N][65];
int num_of_digits[65];
long long numbers[N];

int main()
{
    ios :: sync_with_stdio(false);
    int n;
    cin >> n;
    int cnt = 0;
    int cnt0 = 0;
    int num0 = 0;
    for(int i=0; i<n; i++)
    {
        int k;
        cin >> k;
        numbers[i]=k;
        cnt += 1-k%2;
        if(k==0)
            cnt0++;
        for(int j=0; k>0; j++, k/=2)
        {
            digits[i][j]=k%2;
            num_of_digits[j]+=k%2;
        }
    }
    for(int i=1; i<=64; i++)
        if(num_of_digits[i]%2==1)
            num0++;
    num0+= n%2;

    if(cnt0==cnt)
        while(true);

    if(cnt0==cnt && num0==0 )
        cnt+=2;
    cout << cnt;
    return 0;
}